#ifndef STANDARDMESH_H
#define STANDARDMESH_H

#include "vertex.h"
#include "mesh.h"

class StandardMesh : public Mesh{
protected:
    std::vector<TexturedVertex> vertices;

    virtual int getNbVertices()
    {
        return vertices.size();
    }

    virtual int getSizeofVertexType()
    {
        return sizeof(TexturedVertex);
    }

    virtual void* getVertexData()
    {
        return (void*)(vertices.data());
    }

    virtual void setAttribPointer();

public:

    void addVertex(const TexturedVertex& v);

};

#endif // STANDARDMESH_H
